/*
 * ide_cfg.c
 *
 * IDE configuration file.
 *
 * Copyright (C) 2002 OKTET Ltd., St.-Petersburg, Russia
 * Author: Eugeny S. Mints <Eugeny.Mints@oktet.ru>
 *
 * The license and distribution terms for this file may be
 * found in the file LICENSE in this distribution or at
 * http://www.OARcorp.com/rtems/license.html.
 *
 * $Id: ide_cfg.c,v 1.5 2002/10/11 05:54:54 jack Exp $
 */
#include <libchip/ide_ctrl_cfg.h>

extern ide_ctrl_fns_t tr_ctrl_fns;

ide_controller_bsp_table_t IDE_Controller_Table[] = {
    {"/dev/hdz0",  /* controlller name */
     IDE_CUSTOM,   /* chip type */
     &tr_ctrl_fns, /* controller's routine */
     NULL,         /* BSP dependant probe */
     0,            /* status - shoul be zero */
     0xB4000000,   /* controller registers base address */
     1,            /* 0 - poll, 1 - interrupt driven */
     24,           /* interrupt vector */
     NULL          /* should be NULL */
    }
};

unsigned long IDE_Controller_Count = sizeof(IDE_Controller_Table) /
                                     sizeof(ide_controller_bsp_table_t);

