/*
 *  transas_fpga_v02_ide.h
 *
 *  Macros and defines for Transas IDE chip on FPGA version 2 
 *
 *  Copyright (C) 2002 OKTET Ltd., St.-Petersburg, Russia
 *  Author: Eugeny S. Mints <Eugeny.Mints@oktet.ru>
 *
 *  The license and distribution terms for this file may be
 *  found in the file LICENSE in this distribution or at
 *  http://www.OARcorp.com/rtems/license.html.
 *
 * $Id: transas_fpga_v02_ide.h,v 1.5 2002/09/25 13:18:44 jack Exp $
 */

#ifndef _TRANSAS_FPGA_V02_IDE_H
#define _TRANSAS_FPGA_V02_IDE_H

#ifdef __cplusplus
extern "C" {
#endif

/* only word access to registers */
typedef unsigned16 fpga_v02_ide_register_t;

#define TR_IDE_CTRL_REG_MASK 0x0010

/* macros for registers access */
#define TR_IDE_REG_WRITE(io_base, reg, word) \
    do{ \
       *((fpga_v02_ide_register_t *)(((io_base) + ((reg) << 1)) & \
         ~TR_IDE_CTRL_REG_MASK)) = (fpga_v02_ide_register_t)(word); \
    } while (0)

#define TR_IDE_CTRL_REG_WRITE(io_base, reg, word) \
    do{ \
       *((fpga_v02_ide_register_t *)(((io_base) + ((reg) << 1)) | \
         TR_IDE_CTRL_REG_MASK)) = (fpga_v02_ide_register_t)(word); \
    } while (0)

#define TR_IDE_CMD_REG8_READ(io_base, reg, byte) \
    do{ \
       (byte) = (unsigned8)(*((fpga_v02_ide_register_t *)\
                (((io_base) + ((reg) << 1)) & ~TR_IDE_CTRL_REG_MASK))); \
    } while (0)

#define TR_IDE_CTRL_REG8_READ(io_base, reg, byte) \
    do{ \
       (byte) = (unsigned8)(*((fpga_v02_ide_register_t *)\
                (((io_base) + ((reg) << 1)) | TR_IDE_CTRL_REG_MASK))); \
    } while (0)

#define TR_IDE_CMD_REG16_READ(io_base, reg, word) \
    do{ \
       (word) = (unsigned16)(*((fpga_v02_ide_register_t *)\
                (((io_base) + ((reg) << 1)) & ~TR_IDE_CTRL_REG_MASK))); \
    } while (0)

#ifdef __cplusplus
} 
#endif

#endif /* _TRANSAS_FPGA_V02_IDE_H */



